blob: a4638490ae4ad9289c3a63ac0e219770013c329c [file] [log] [blame]
Peter Stuge09377b72011-08-21 06:24:55 +02001#!/bin/sh
Stefan Reinauer074d9132009-09-26 16:43:17 +00002#
Stefan Reinauer5f1ad892010-05-17 11:02:25 +00003# Copyright (C) 2008-2010 by coresystems GmbH
Stefan Reinauer074d9132009-09-26 16:43:17 +00004# written by Patrick Georgi <patrick.georgi@coresystems.de> and
5# Stefan Reinauer <stefan.reinauer@coresystems.de>
Stefan Reinauer14e22772010-04-27 06:56:47 +00006#
Marc Jones2aac3f62011-08-08 16:07:50 -06007# Copyright (C) 2011 by Sage Electronic Engineering
8#
Stefan Reinauer074d9132009-09-26 16:43:17 +00009# This program is free software; you can redistribute it and/or modify
10# it under the terms of the GNU General Public License as published by
11# the Free Software Foundation; version 2 of the License.
12#
13# This program is distributed in the hope that it will be useful,
14# but WITHOUT ANY WARRANTY; without even the implied warranty of
15# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
16# GNU General Public License for more details.
17#
18# You should have received a copy of the GNU General Public License
19# along with this program; if not, write to the Free Software
Patrick Georgib890a122015-03-26 15:17:45 +010020# Foundation, Inc.
Stefan Reinauer074d9132009-09-26 16:43:17 +000021#
22
Stefan Reinauerd7649122015-06-09 11:44:25 -070023cd $(dirname $0)
Patrick Georgi8135dba2015-03-17 21:05:20 +010024
Stefan Reinauer14ce2132015-06-05 13:01:13 -070025CROSSGCC_DATE="June 4th, 2015"
26CROSSGCC_VERSION="1.29"
Stefan Reinauer074d9132009-09-26 16:43:17 +000027
28# default settings
Stefan Reinauerd7649122015-06-09 11:44:25 -070029TARGETDIR=$(pwd)/xgcc
Stefan Reinauer074d9132009-09-26 16:43:17 +000030TARGETARCH=i386-elf
31DESTDIR=
32
Stefan Reinauer699ac272015-06-05 12:43:28 -070033# GCC toolchain version numbers
Patrick Georgi53c388f2015-03-07 09:55:18 +010034GMP_VERSION=6.0.0
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070035MPFR_VERSION=3.1.2
Paul Menzele6619422015-02-23 10:33:59 +010036MPC_VERSION=1.0.3
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000037LIBELF_VERSION=0.8.13
Patrick Georgi53c388f2015-03-07 09:55:18 +010038GCC_VERSION=4.9.2
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070039GCC_AUTOCONF_VERSION=2.69
Patrick Georgi53c388f2015-03-07 09:55:18 +010040BINUTILS_VERSION=2.25
41GDB_VERSION=7.9
42IASL_VERSION=20150204
43PYTHON_VERSION=3.4.3
Idwer Vollering296a0152012-10-26 01:48:04 +020044EXPAT_VERSION=2.1.0
Stefan Reinauer14ce2132015-06-05 13:01:13 -070045# CLANG version number
46CLANG_VERSION=3.6.1
Stefan Reinauer074d9132009-09-26 16:43:17 +000047
Stefan Reinauer699ac272015-06-05 12:43:28 -070048# GCC toolchain archive locations
Patrick Georgi53c388f2015-03-07 09:55:18 +010049GMP_ARCHIVE="http://ftpmirror.gnu.org/gmp/gmp-${GMP_VERSION}a.tar.bz2"
Patrick Georgi6e61ad32012-05-12 23:19:30 +020050MPFR_ARCHIVE="http://ftpmirror.gnu.org/mpfr/mpfr-${MPFR_VERSION}.tar.bz2"
Idwer Vollering7962fc72012-10-25 02:14:09 +020051MPC_ARCHIVE="http://ftpmirror.gnu.org/mpc/mpc-${MPC_VERSION}.tar.gz"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000052LIBELF_ARCHIVE="http://www.mr511.de/software/libelf-${LIBELF_VERSION}.tar.gz"
Idwer Vollering1cfee0b2012-10-25 02:03:53 +020053GCC_ARCHIVE="http://ftpmirror.gnu.org/gcc/gcc-${GCC_VERSION}/gcc-${GCC_VERSION}.tar.bz2"
Stefan Reinauer0d2119d2013-07-10 14:27:56 -070054BINUTILS_ARCHIVE="http://ftpmirror.gnu.org/binutils/binutils-${BINUTILS_VERSION}.tar.bz2"
Patrick Georgi53c388f2015-03-07 09:55:18 +010055GDB_ARCHIVE="http://ftpmirror.gnu.org/gdb/gdb-${GDB_VERSION}.tar.xz"
56IASL_ARCHIVE="https://acpica.org/sites/acpica/files/acpica-unix-${IASL_VERSION}.tar.gz"
57PYTHON_ARCHIVE="http://www.python.org/ftp/python/${PYTHON_VERSION}/Python-${PYTHON_VERSION}.tar.xz"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010058EXPAT_ARCHIVE="http://downloads.sourceforge.net/sourceforge/expat/expat-${EXPAT_VERSION}.tar.gz"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070059# CLANG toolchain archive locations
60LLVM_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/llvm-${CLANG_VERSION}.src.tar.xz"
61CFE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/cfe-${CLANG_VERSION}.src.tar.xz"
62CRT_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/compiler-rt-${CLANG_VERSION}.src.tar.xz"
63CTE_ARCHIVE="http://llvm.org/releases/${CLANG_VERSION}/clang-tools-extra-${CLANG_VERSION}.src.tar.xz"
Stefan Reinauer074d9132009-09-26 16:43:17 +000064
Stefan Reinauer699ac272015-06-05 12:43:28 -070065# GCC toolchain directories
Stefan Reinauer074d9132009-09-26 16:43:17 +000066GMP_DIR="gmp-${GMP_VERSION}"
67MPFR_DIR="mpfr-${MPFR_VERSION}"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +000068MPC_DIR="mpc-${MPC_VERSION}"
69LIBELF_DIR="libelf-${LIBELF_VERSION}"
Stefan Reinauer074d9132009-09-26 16:43:17 +000070GCC_DIR="gcc-${GCC_VERSION}"
71BINUTILS_DIR="binutils-${BINUTILS_VERSION}"
72GDB_DIR="gdb-${GDB_VERSION}"
Marc Jones2aac3f62011-08-08 16:07:50 -060073IASL_DIR="acpica-unix-${IASL_VERSION}"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010074PYTHON_DIR="Python-${PYTHON_VERSION}"
75EXPAT_DIR="expat-${EXPAT_VERSION}"
Stefan Reinauer14ce2132015-06-05 13:01:13 -070076# CLANG toolchain directories
77LLVM_DIR="llvm-${CLANG_VERSION}.src"
78CFE_DIR="cfe-${CLANG_VERSION}.src"
79CRT_DIR="compiler-rt-${CLANG_VERSION}.src"
80CTE_DIR="clang-tools-extra-${CLANG_VERSION}.src"
Stefan Reinauer074d9132009-09-26 16:43:17 +000081
Patrick Georgi6321f522015-02-27 23:36:26 +010082unset MAKELEVEL MAKEFLAGS
83
Stefan Reinauer074d9132009-09-26 16:43:17 +000084SAVETEMPS=0
Stefan Reinauer14ce2132015-06-05 13:01:13 -070085BUILDCLANG=0
Stefan Reinauer2c3cd122011-11-01 21:43:50 +010086SKIPGDB=1
87SKIPPYTHON=1
Stefan Reinauer074d9132009-09-26 16:43:17 +000088
Patrick Georgi1861ff72011-10-31 12:15:55 +010089red='\033[0;31m'
90RED='\033[1;31m'
91green='\033[0;32m'
92GREEN='\033[1;32m'
93blue='\033[0;34m'
94BLUE='\033[1;34m'
95cyan='\033[0;36m'
96CYAN='\033[1;36m'
97NC='\033[0m' # No Color
Stefan Reinauer074d9132009-09-26 16:43:17 +000098
Stefan Reinauerd7649122015-06-09 11:44:25 -070099UNAME=$(uname)
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700100
Patrick Georgi198d23c2012-12-08 08:02:44 +0100101normalize_dirs()
102{
103 mkdir -p $DESTDIR$TARGETDIR/lib
104 test -d $DESTDIR$TARGETDIR/lib32 && mv $DESTDIR$TARGETDIR/lib32/* $DESTDIR$TARGETDIR/lib
105 test -d $DESTDIR$TARGETDIR/lib64 && mv $DESTDIR$TARGETDIR/lib64/* $DESTDIR$TARGETDIR/lib
106 rmdir -p $DESTDIR$TARGETDIR/lib32 $DESTDIR$TARGETDIR/lib64
107
108 perl -pi -e "s,/lib32,/lib," $DESTDIR$TARGETDIR/lib/*.la
109 perl -pi -e "s,/lib64,/lib," $DESTDIR$TARGETDIR/lib/*.la
110}
111
Patrick Georgib7062882015-02-24 10:52:14 +0100112searchtool()
Stefan Reinauer074d9132009-09-26 16:43:17 +0000113{
114 # $1 short name
Patrick Georgib7062882015-02-24 10:52:14 +0100115 # $2 search string
116 # $3 soft fail if set
117 # result: file name of that tool on stdout
118 # or no output if nothing suitable was found
119 search=GNU
120 if [ -n "$2" ]; then
121 search="$2"
122 fi
Stefan Reinauer074d9132009-09-26 16:43:17 +0000123 for i in "$1" "g$1" "gnu$1"; do
Stefan Reinauerd7649122015-06-09 11:44:25 -0700124 if test -x "$(which $i 2>/dev/null)"; then
125 if test $(cat /dev/null | $i --version 2>&1 |grep -c "$search") \
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100126 -gt 0; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000127 echo $i
128 return
129 fi
130 fi
131 done
Andrew Wub67e9a12014-04-28 18:13:44 +0800132 # A workaround for OSX 10.9 and some BSDs, whose nongnu
133 # patch and tar also work.
Patrick Georgi7cb26b42015-04-28 21:29:22 +0200134 if [ $UNAME = "Darwin" -o $UNAME = "FreeBSD" -o $UNAME = "NetBSD" -o $UNAME = "OpenBSD" ]; then
Patrick Georgib7062882015-02-24 10:52:14 +0100135 if [ "$1" = "patch" -o "$1" = "tar" ]; then
Stefan Reinauerd7649122015-06-09 11:44:25 -0700136 if test -x "$(which $1 2>/dev/null)"; then
Zheng Bao36156ff2012-09-28 16:18:58 +0800137 echo $1
138 return
139 fi
140 fi
141 fi
Stefan Reinauerd7649122015-06-09 11:44:25 -0700142 if [ "$(echo $1 | cut -b -3)" = "sha" ]; then
zbao939dc842015-04-30 04:44:07 +0800143 if [ $UNAME = "FreeBSD" ]; then
Stefan Reinauerd7649122015-06-09 11:44:25 -0700144 if test -x "$(which sha1 2>/dev/null)"; then
zbao939dc842015-04-30 04:44:07 +0800145 echo sha1
146 return
147 fi
148 fi
149 if [ $UNAME = "NetBSD" ]; then
Stefan Reinauerd7649122015-06-09 11:44:25 -0700150 if test -x "$(which cksum 2>/dev/null)"; then
151 echo cksum -a $(echo $1 | sed -e 's,sum,,')
zbao939dc842015-04-30 04:44:07 +0800152 return
153 fi
154 fi
155 if [ $UNAME = "Darwin" ]; then
Stefan Reinauerd7649122015-06-09 11:44:25 -0700156 if test -x "$(which openssl 2>/dev/null)"; then
157 echo openssl $(echo $1 | sed -e 's,sum,,')
zbao939dc842015-04-30 04:44:07 +0800158 return
159 fi
160 fi
161 fi
Patrick Georgiae5ab602015-04-29 23:30:15 +0200162 printf "${RED}ERROR:${red} Missing tool: Please install $1 (eg using your OS packaging system)${NC}\n" >&2
Patrick Georgib7062882015-02-24 10:52:14 +0100163 [ -z "$3" ] && exit 1
164 false
Stefan Reinauer074d9132009-09-26 16:43:17 +0000165}
166
Stefan Reinauerd7649122015-06-09 11:44:25 -0700167TAR=$(searchtool tar) || exit $?
168PATCH=$(searchtool patch) || exit $?
169MAKE=$(searchtool make) || exit $?
170CMAKE=$(searchtool cmake "cmake") || exit $?
171SHA1SUM=$(searchtool sha1sum)
172SHA512SUM=$(searchtool sha512sum)
Stefan Reinauer699ac272015-06-05 12:43:28 -0700173CHECKSUM=$SHA1SUM
Stefan Reinauer074d9132009-09-26 16:43:17 +0000174
Patrick Georgib7062882015-02-24 10:52:14 +0100175searchtool m4 > /dev/null
176searchtool bison > /dev/null
177searchtool flex flex > /dev/null
178searchtool g++ "Free Software Foundation" nofail > /dev/null || \
Patrick Georgi915c4fc2015-03-09 13:58:23 +0100179searchtool clang "clang version" > /dev/null
180searchtool wget > /dev/null
181searchtool bzip2 "bzip2," > /dev/null
Patrick Georgi5fb2b5c2012-05-12 23:25:23 +0200182
Stefan Reinauer88935482015-06-05 09:51:10 -0700183download() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700184 package=$1
185 archive="$(eval echo \$$package"_ARCHIVE")"
Stefan Reinauer699ac272015-06-05 12:43:28 -0700186
Stefan Reinauerd7649122015-06-09 11:44:25 -0700187 FILE=$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700188 printf " * $FILE "
189
190 test -f tarballs/$FILE && \
191 (test -z "$CHECKSUM" || \
Stefan Reinauerd7649122015-06-09 11:44:25 -0700192 test "$(cat sum/$FILE.cksum 2>/dev/null | sed -e 's,.*\([0-9a-f]\{40\}\).*,\1,')" = "$($CHECKSUM tarballs/$FILE 2>/dev/null | sed -e 's,.*\([0-9a-f]\{40\}\).*,\1,')" ) && \
Stefan Reinauer88935482015-06-05 09:51:10 -0700193 printf "(cached)" || (
194 printf "(downloading)"
195 rm -f tarballs/$FILE
196 cd tarballs
Stefan Reinauer699ac272015-06-05 12:43:28 -0700197 wget --no-check-certificate -q $archive
Stefan Reinauer88935482015-06-05 09:51:10 -0700198 cd ..
199 test ! -f sum/$FILE.cksum && test -f tarballs/$FILE && \
200 (test -z "$CHECKSUM" || $CHECKSUM tarballs/$FILE > sum/$FILE.cksum ) && \
201 printf "(checksum created. ${RED}Note. Please upload sum/$FILE.cksum if the corresponding archive is upgraded.${NC})"
202 )
203 test -f tarballs/$FILE || \
204 printf "\n${RED}Failed to download $FILE.${NC}\n"
205 test -f tarballs/$FILE || exit 1
206 printf "\n"
207}
208
209unpack_and_patch() {
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700210 package=$1
211 archive="$(eval echo \$$package"_ARCHIVE")"
212 dir="$(eval echo \$$package"_DIR")"
Stefan Reinauer88935482015-06-05 09:51:10 -0700213 test -d ${dir} && test -f ${dir}/.unpack_success || (
Stefan Reinauerd7649122015-06-09 11:44:25 -0700214 printf " * $(basename $archive)\n"
Stefan Reinauer88935482015-06-05 09:51:10 -0700215 FLAGS=zxf
Stefan Reinauerd7649122015-06-09 11:44:25 -0700216 suffix=$(echo $archive | sed 's,.*\.,,')
Stefan Reinauer88935482015-06-05 09:51:10 -0700217 test "$suffix" = "gz" && FLAGS=zxf
218 test "$suffix" = "bz2" && FLAGS=jxf
219 test "$suffix" = "xz" && FLAGS="--xz -xf"
220 test "$suffix" = "lzma" && FLAGS="--lzma -xf"
Stefan Reinauerd7649122015-06-09 11:44:25 -0700221 $TAR $FLAGS tarballs/$(basename $archive)
Stefan Reinauer88935482015-06-05 09:51:10 -0700222 for patch in patches/${dir}_*.patch; do
223 test -r $patch || continue
Stefan Reinauerd7649122015-06-09 11:44:25 -0700224 printf " o $(basename $patch)\n"
225 $PATCH -s -N -p0 < $(echo $patch) || \
Stefan Reinauer88935482015-06-05 09:51:10 -0700226 printf "\n${RED}Failed $patch.${NC}\n"
227 done
228 touch ${dir}/.unpack_success
229 )
230}
231
Patrick Georgi74c06422015-03-25 18:40:13 +0100232wait_for_build() {
233 # $1: directory in which log file and failure marker are stored
234 cat > "$1/crossgcc-build.log"
235 test -r "$1/.failed" && printf "${RED}failed${NC}. Check $1/crossgcc-build.log.\n" || \
236 printf "${green}ok${NC}\n"
237 test -r "$1/.failed" && exit 1
238 true
239}
240
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700241build() {
242 package=$1
243 version="$(eval echo \$$package"_VERSION")"
244 [[ "$PACKAGES" == *$package* ]] && \
245 if [ -f ${BUILDDIRPREFIX}-$package/.success ]; then
246 printf "Skipping $package as it is already built\n"
247 else
248 printf "Building $package $version ... "
249 (
250 cd ${BUILDDIRPREFIX}-$package
251 rm -f .failed
252 build_${package}
253 if [ ! -f .failed ]; then touch .success; fi
254 ) 2>&1 | wait_for_build "${BUILDDIRPREFIX}-$package" || exit 1
255 fi
256}
257
Stefan Reinauer074d9132009-09-26 16:43:17 +0000258cleanup()
259{
260 printf "Cleaning up temporary files... "
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700261 for package in $PACKAGES; do
262 rm -rf ${BUILDDIRPREFIX}-$package $(eval echo \$$package"_DIR")
263 done
Stefan Reinauer074d9132009-09-26 16:43:17 +0000264 printf "${green}ok${NC}\n"
265}
266
267myhelp()
268{
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700269 printf "Usage: $0 [-V] [-c] [-p <platform>] [-d <target directory>] [-D <dest dir>] [-C] [-G] [-S]\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000270 printf " $0 [-V|--version]\n"
271 printf " $0 [-h|--help]\n\n"
272
273 printf "Options:\n"
274 printf " [-V|--version] print version number and exit\n"
275 printf " [-h|--help] print this help and exit\n"
276 printf " [-c|--clean] remove temporary files before build\n"
277 printf " [-t|--savetemps] don't remove temporary files after build\n"
Patrick Georgic1a75b12011-11-04 21:37:14 +0100278 printf " [-y|--ccache] Use ccache when building cross compiler\n"
Patrick Georgi73166c72010-04-14 20:42:42 +0000279 printf " [-j|--jobs <num>] run <num> jobs in parallel in make\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700280 printf " [-C|--clang] build CLANG toolchain"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000281 printf " [-p|--platform <platform>] target platform to build cross compiler for\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700282 printf " (defaults to $TARGETARCH) *)\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000283 printf " [-d|--directory <target dir>] target directory to install cross compiler to\n"
284 printf " (defaults to $TARGETDIR)\n\n"
285 printf " [-D|--destdir <dest dir>] destination directory to install cross compiler to\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100286 printf " (for RPM builds, default unset)\n"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700287 printf " [-G|--gdb] build GNU debugger *)\n"
288 printf " [-S|--scripting] build scripting support for GDB *)\n\n"
289 printf " *) option only available when building GCC toolchain (not with CLANG)\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000290}
291
292myversion()
293{
294 # version tag is always printed, so just print the license here
295
296 cat << EOF
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000297Copyright (C) 2008-2010 by coresystems GmbH
Marc Jones2aac3f62011-08-08 16:07:50 -0600298Copyright (C) 2011 by Sage Electronic Engineering
Stefan Reinauer074d9132009-09-26 16:43:17 +0000299
300This program is free software; you can redistribute it and/or modify
301it under the terms of the GNU General Public License as published by
302the Free Software Foundation; version 2 of the License.
303
304This program is distributed in the hope that it will be useful,
305but WITHOUT ANY WARRANTY; without even the implied warranty of
306MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
307GNU General Public License for more details.
308
309EOF
310}
311
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700312build_GMP() {
313 CC="$CC" CFLAGS="-Os" ../${GMP_DIR}/configure --disable-shared --enable-fat --prefix=$TARGETDIR $OPTIONS \
314 || touch .failed
315 $MAKE $JOBS || touch .failed
316 $MAKE install DESTDIR=$DESTDIR || touch .failed
317
318 normalize_dirs
319}
320
321build_MPFR() {
322 test $UNAME = "Darwin" && CFLAGS="$CFLAGS -force_cpusubtype_ALL"
323 CC="$CC" ../${MPFR_DIR}/configure --disable-shared --prefix=$TARGETDIR \
324 --infodir=$TARGETDIR/info \
325 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
326 touch .failed
327 $MAKE $JOBS || touch .failed
328 $MAKE install DESTDIR=$DESTDIR || touch .failed
329
330 normalize_dirs
331
332 # work around build problem of libgmp.la
333 if [ "$DESTDIR" != "" ]; then
334 perl -pi -e "s,$DESTDIR,," $DESTDIR$TARGETDIR/libgmp.la
335 fi
336}
337
338build_MPC() {
339 CC="$CC" ../${MPC_DIR}/configure --disable-shared --prefix=$TARGETDIR \
340 --infodir=$TARGETDIR/info --with-mpfr=$DESTDIR$TARGETDIR \
341 --with-gmp=$DESTDIR$TARGETDIR CFLAGS="$HOSTCFLAGS" || \
342 touch .failed
343 $MAKE $JOBS || touch .failed
344 $MAKE install DESTDIR=$DESTDIR || touch .failed
345
346 normalize_dirs
347}
348
349build_LIBELF() {
350 CC="$CC" CFLAGS="$HOSTCFLAGS" libelf_cv_elf_h_works=no \
351 ../${LIBELF_DIR}/configure --disable-shared --prefix=$TARGETDIR \
352 --infodir=$TARGETDIR/info CFLAGS="$HOSTCFLAGS" || touch .failed
353 $MAKE $JOBS || touch .failed
354 $MAKE install prefix=$DESTDIR$TARGETDIR || touch .failed
355
356 normalize_dirs
357}
358
359build_BINUTILS() {
360 # What a pain: binutils don't come with configure
361 # script anymore. Create it:
362 cd ../binutils-${BINUTILS_VERSION}/
363 autoconf
364 cd -
365 # Now build binutils
366 rm -f .failed
367 CC="$CC" ../binutils-${BINUTILS_VERSION}/configure --prefix=$TARGETDIR \
368 --target=${TARGETARCH} --disable-werror --disable-nls \
369 $USE_GOLD CFLAGS="$HOSTCFLAGS" || touch .failed
370 $MAKE $JOBS || touch .failed
371 $MAKE install DESTDIR=$DESTDIR || touch .failed
372}
373
374
375build_GCC() {
376 # Even worse than binutils: GCC does not come with configure
377 # script anymore, but also enforces an obsolete autoconf version
378 # to create it. This is a poster child of how autotools help make
379 # software portable.
380 cd ../gcc-${GCC_VERSION}
381 sed '/dnl Ensure exactly this Autoconf version is used/d' \
382 config/override.m4 > config/override.m4.new
Stefan Reinauerd7649122015-06-09 11:44:25 -0700383 autoconf_version=$(autoconf -V | grep "autoconf" | tr ' ' '\n' | tail -1)
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700384 sed "s/${GCC_AUTOCONF_VERSION}/${autoconf_version}/g" \
385 config/override.m4.new > config/override.m4
386 autoconf
387 cd -
388
389 # Now, finally, we can build gcc:
390 # GCC does not honour HOSTCFLAGS at all. CFLAGS are used for
391 # both target and host object files. This is pretty misdesigned.
392 # There's a work-around called CFLAGS_FOR_BUILD and CFLAGS_FOR_TARGET
393 # but it does not seem to work properly. At least the host library
394 # libiberty is not compiled with CFLAGS_FOR_BUILD.
395 CC="$CC" CFLAGS_FOR_TARGET="-O2" CFLAGS="$HOSTCFLAGS" \
396 CFLAGS_FOR_BUILD="$HOSTCFLAGS" ../gcc-${GCC_VERSION}/configure \
397 --prefix=$TARGETDIR --libexecdir=$TARGETDIR/lib \
398 --target=${TARGETARCH} --disable-werror --disable-shared \
399 --disable-libssp --disable-bootstrap --disable-nls \
400 --disable-libquadmath --without-headers \
401 $GCC_OPTIONS --enable-languages="c" $USE_GOLD \
402 --with-gmp=$DESTDIR$TARGETDIR --with-mpfr=$DESTDIR$TARGETDIR \
403 --with-mpc=$DESTDIR$TARGETDIR --with-libelf=$DESTDIR$TARGETDIR \
404 --with-pkgversion="coreboot toolchain v$CROSSGCC_VERSION $CROSSGCC_DATE" \
405 || touch .failed
406 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-gcc || touch .failed
407 $MAKE install-gcc DESTDIR=$DESTDIR || touch .failed
408
Stefan Reinauerd7649122015-06-09 11:44:25 -0700409 if [ "$(echo $TARGETARCH | grep -c -- -mingw32)" -eq 0 ]; then
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700410 $MAKE $JOBS CFLAGS_FOR_BUILD="$HOSTCFLAGS" all-target-libgcc || touch .failed
411 $MAKE install-target-libgcc DESTDIR=$DESTDIR || touch .failed
412 fi
413}
414
415build_EXPAT() {
416 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${EXPAT_DIR}/configure --disable-shared \
417 --prefix=$TARGETDIR --target=${TARGETARCH} || touch .failed
418 $MAKE || touch .failed
419 $MAKE install DESTDIR=$DESTDIR || touch .failed
420
421 normalize_dirs
422}
423
424build_PYTHON() {
425 CC="$CC" CFLAGS="$HOSTCFLAGS" ../${PYTHON_DIR}/configure --prefix=$TARGETDIR \
426 --target=${TARGETARCH} || touch .failed
427 $MAKE $JOBS || touch .failed
428 $MAKE install DESTDIR=$DESTDIR || touch .failed
429
430 normalize_dirs
431}
432
433build_GDB() {
434 export PYTHONHOME=$DESTDIR$TARGETDIR
435 if [ $(uname) != "FreeBSD" -a $(uname) != "NetBSD" ]; then
436 LIBDL="-ldl"
437 fi
438 LDFLAGS="-Wl,-rpath,\$\$ORIGIN/../lib/ -L$DESTDIR$TARGETDIR/lib \
439 -lpthread $LIBDL -lutil" \
440 CC="$CC" CFLAGS="$HOSTCFLAGS -I$DESTDIR$TARGETDIR/include" \
441 ../gdb-${GDB_VERSION}/configure --prefix=$TARGETDIR \
442 --target=${TARGETARCH} --disable-werror --disable-nls
443 $MAKE $JOBS || touch .failed
444 $MAKE install DESTDIR=$DESTDIR || touch .failed
445}
446
447build_IASL() {
448 RDIR=$PWD
449 cd ../$IASL_DIR/generate/unix
450 CFLAGS="$HOSTCFLAGS"
451 HOST="_LINUX"
452 test $UNAME = "Darwin" && HOST="_APPLE"
453 test $UNAME = "FreeBSD" && HOST="_FreeBSD"
454 test $UNAME = "Cygwin" && HOST="_CYGWIN"
455 HOST="$HOST" OPT_CFLAGS="-O -D_FORTIFY_SOURCE=2" CFLAGS="$CFLAGS" $MAKE CC="$CC" iasl || touch $RDIR/.failed
456 rm -f $DESTDIR$TARGETDIR/bin/iasl || touch $RDIR/.failed
457 cp bin/iasl $DESTDIR$TARGETDIR/bin || touch $RDIR/.failed
458}
459
460build_LLVM() {
461 cd ..
462 ln -sf $PWD/$CFE_DIR $LLVM_DIR/tools/clang
463 ln -sf $PWD/$CTE_DIR $LLVM_DIR/tools/clang/tools/extra
464 ln -sf $PWD/$CRT_DIR $LLVM_DIR/projects/compiler-rt
465 cd -
466
467 $CMAKE -G "Unix Makefiles" -DCMAKE_INSTALL_PREFIX=$DESTDIR$TARGETDIR \
468 -DCMAKE_BUILD_TYPE=Release ../$LLVM_DIR || touch .failed
469 $MAKE $JOBS || touch .failed
470 $MAKE install || touch .failed
471
472 cp -a ../$CFE_DIR/tools/scan-build/* $DESTDIR$TARGETDIR/bin
473 cp -a ../$CFE_DIR/tools/scan-view/* $DESTDIR$TARGETDIR/bin
474}
475
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700476printf "${blue}Welcome to the ${red}coreboot${blue} cross toolchain builder v$CROSSGCC_VERSION ($CROSSGCC_DATE)${NC}\n\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000477
Patrick Georgi6bba29f2010-01-29 17:40:52 +0000478# Look if we have getopt. If not, build it.
479export PATH=$PATH:.
480getopt - > /dev/null 2>/dev/null || gcc -o getopt getopt.c
481
Stefan Reinauer074d9132009-09-26 16:43:17 +0000482# parse parameters.. try to find out whether we're running GNU getopt
Stefan Reinauerd7649122015-06-09 11:44:25 -0700483getoptbrand="$(getopt -V | sed -e '1!d' -e 's,^\(......\).*,\1,')"
Peter Stuge09377b72011-08-21 06:24:55 +0200484if [ "${getoptbrand}" = "getopt" ]; then
Stefan Reinauer074d9132009-09-26 16:43:17 +0000485 # Detected GNU getopt that supports long options.
Stefan Reinauerd7649122015-06-09 11:44:25 -0700486 args=$(getopt -l version,help,clean,directory:,platform:,jobs:,destdir:,savetemps,skip-gdb,ccache,clang Vhcd:p:j:D:tGyC -- "$@")
Stefan Reinauer074d9132009-09-26 16:43:17 +0000487 eval set "$args"
488else
489 # Detected non-GNU getopt
Stefan Reinauerd7649122015-06-09 11:44:25 -0700490 args=$(getopt Vhcd:p:j:D:tGyC $*)
Stefan Reinauer074d9132009-09-26 16:43:17 +0000491 set -- $args
492fi
493
494if [ $? != 0 ]; then
495 myhelp
496 exit 1
497fi
498
499while true ; do
500 case "$1" in
501 -V|--version) shift; myversion; exit 0;;
502 -h|--help) shift; myhelp; exit 0;;
Patrick Georgi44af57a2013-12-19 22:06:22 +0100503 -c|--clean) shift; clean=1;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000504 -t|--savetemps) shift; SAVETEMPS=1;;
505 -d|--directory) shift; TARGETDIR="$1"; shift;;
506 -p|--platform) shift; TARGETARCH="$1"; shift;;
507 -D|--destdir) shift; DESTDIR="$1"; shift;;
Patrick Georgi73166c72010-04-14 20:42:42 +0000508 -j|--jobs) shift; JOBS="-j $1"; shift;;
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700509 -C|--clang) shift; BUILDCLANG=1;;
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100510 -G|--gdb) shift; SKIPGDB=0;;
511 -S|--scripting) shift; SKIPPYTHON=0;;
Patrick Georgic1a75b12011-11-04 21:37:14 +0100512 -y|--ccache) shift; USECCACHE=1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200513 --) shift; break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000514 -*) printf "Invalid option\n\n"; myhelp; exit 1;;
Patrick Georgid2e0dd52013-06-09 08:05:45 +0200515 *) break;;
Stefan Reinauer074d9132009-09-26 16:43:17 +0000516 esac
517done
518
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700519case "$TARGETARCH" in
Stefan Reinauer24f9cb92015-03-13 22:50:22 +0100520 x86_64-elf) ;;
521 x86_64*) TARGETARCH=x86_64-elf;;
David Hubbard5b0420a2013-05-28 16:33:15 -0600522 i386-elf) ;;
523 i386-mingw32) ;;
Patrick Georgi9b7efa52015-03-08 09:20:36 +0100524 mipsel-elf) ;;
Patrick Georgif0bbc952015-03-07 10:57:25 +0100525 riscv-elf) ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700526 i386*) TARGETARCH=i386-elf;;
Patrick Georgic8883262013-09-19 10:57:58 +0200527 arm*) TARGETARCH=armv7-a-eabi;;
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700528 aarch64*) TARGETARCH=aarch64-elf;;
529 *) printf "${red}WARNING: Unsupported architecture $TARGETARCH.${NC}\n\n"; ;;
Ronald G. Minnichb460a662013-05-26 05:33:35 -0700530esac
531
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700532if [ "$BUILDCLANG" -eq 0 ]; then
533echo "Target architecture is now $TARGETARCH"
Stefan Reinauer699ac272015-06-05 12:43:28 -0700534NAME="${TARGETARCH} cross"
535PACKAGES="GMP MPFR MPC LIBELF BINUTILS GCC IASL"
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700536else
537NAME=clang
538PACKAGES="LLVM CFE CRT CTE"
539fi
Stefan Reinauer699ac272015-06-05 12:43:28 -0700540
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200541BUILDDIRPREFIX=build-${TARGETARCH}
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700542BUILDDIR=$PWD/build-clang
Patrick Georgi3af0aa22013-09-17 20:59:52 +0200543
Patrick Georgi44af57a2013-12-19 22:06:22 +0100544if [ "$clean" = "1" ]; then
545 cleanup
546fi
547
Peter Stugeceacd772011-06-09 04:54:16 +0200548if [ $SKIPGDB -eq 1 ]; then
549 printf "Will skip GDB ... ${green}ok${NC}\n"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100550 if [ $SKIPPYTHON -eq 0 ]; then
551 printf "Python scripting needs GDB ... disabling ... ${green}ok${NC}\n"
552 SKIPPYTHON=1
553 fi
Stefan Reinauer699ac272015-06-05 12:43:28 -0700554else
555 PACKAGES="$PACKAGES GDB"
Stefan Reinauer2c3cd122011-11-01 21:43:50 +0100556fi
Stefan Reinauer699ac272015-06-05 12:43:28 -0700557if [ $SKIPPYTHON -eq 0 ]; then
558 PACKAGES="$PACKAGES EXPAT PYTHON"
Peter Stugeceacd772011-06-09 04:54:16 +0200559fi
560
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700561# coreboot does not like the GOLD linker
562# USE_GOLD="--enable-gold"
563USE_GOLD=""
564GCC_OPTIONS="--enable-lto"
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000565
Stefan Reinauer074d9132009-09-26 16:43:17 +0000566printf "Downloading tar balls ... \n"
567mkdir -p tarballs
Stefan Reinauer699ac272015-06-05 12:43:28 -0700568for P in $PACKAGES; do
569 download $P
Stefan Reinauer074d9132009-09-26 16:43:17 +0000570done
Stefan Reinauer699ac272015-06-05 12:43:28 -0700571printf "Downloaded tar balls ... ${green}ok${NC}\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000572
573printf "Unpacking and patching ... \n"
Stefan Reinauer699ac272015-06-05 12:43:28 -0700574for P in $PACKAGES; do
575 unpack_and_patch $P
Stefan Reinauer074d9132009-09-26 16:43:17 +0000576done
Stefan Reinauer699ac272015-06-05 12:43:28 -0700577printf "Unpacked and patched ... ${green}ok${NC}\n"
Stefan Reinauer074d9132009-09-26 16:43:17 +0000578
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700579if [[ "$PACKAGES" == *GCC* ]]; then
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700580CC=cc
Stefan Reinauer0d2119d2013-07-10 14:27:56 -0700581if [ $UNAME = "Darwin" ]; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000582 #GCC_OPTIONS="$GCC_OPTIONS --enable-threads=posix"
583
584 # generally the OS X compiler can create x64 binaries.
585 # Per default it generated i386 binaries in 10.5 and x64
586 # binaries in 10.6 (even if the kernel is 32bit)
587 # For some weird reason, 10.5 autodetects an ABI=64 though
588 # so we're setting the ABI explicitly here.
Stefan Reinauerd7649122015-06-09 11:44:25 -0700589 if [ $(sysctl -n hw.optional.x86_64 2>/dev/null) -eq 1 ] 2>/dev/null; then
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000590 OPTIONS="ABI=64"
591 else
592 OPTIONS="ABI=32"
593 fi
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700594
Stefan Reinauer4266b922012-12-05 16:18:32 -0800595 # In Xcode 4.5.2 the default compiler is clang.
596 # However, this compiler fails to compile gcc 4.7.x. As a
597 # workaround it's possible to compile gcc with llvm-gcc.
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700598 if $CC -v 2>&1 | grep -q LLVM; then
Stefan Reinauer4266b922012-12-05 16:18:32 -0800599 CC=llvm-gcc
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700600 fi
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000601fi
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700602fi # GCC
Stefan Reinauer5f1ad892010-05-17 11:02:25 +0000603
Patrick Georgic1a75b12011-11-04 21:37:14 +0100604if [ "$USECCACHE" = 1 ]; then
605 CC="ccache $CC"
606fi
607
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700608for package in $PACKAGES; do
609 mkdir -p ${BUILDDIRPREFIX}-$package
610done
Stefan Reinauer16bd7892012-12-07 23:57:01 +0100611
612mkdir -p $DESTDIR$TARGETDIR/bin
613export PATH=$DESTDIR$TARGETDIR/bin:$PATH
614
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700615build GMP
Stefan Reinauer074d9132009-09-26 16:43:17 +0000616
Stefan Reinauer9491b4d2011-10-11 22:37:59 -0700617# Now set CFLAGS to match GMP CFLAGS but strip out -pedantic
618# as GCC 4.6.x fails if it's there.
Stefan Reinauerd7649122015-06-09 11:44:25 -0700619HOSTCFLAGS=$(grep __GMP_CFLAGS $DESTDIR$TARGETDIR/include/gmp.h |cut -d\" -f2 |\
620 sed s,-pedantic,,)
Stefan Reinauer074d9132009-09-26 16:43:17 +0000621
Stefan Reinauere7757bd2015-06-05 13:59:44 -0700622build MPFR
623build MPC
624build LIBELF
625build BINUTILS
626build GCC
627build EXPAT
628build PYTHON
629build GDB
630build IASL
631build LLVM
Stefan Reinauer14ce2132015-06-05 13:01:13 -0700632
Stefan Reinauer699ac272015-06-05 12:43:28 -0700633# Adding git information of current tree to target directory
634# for reproducibility
Stefan Reinauerd7649122015-06-09 11:44:25 -0700635PROGNAME=$(basename "$0")
Patrick Georgi5602f2c2015-03-28 15:48:47 +0100636rm -f "$DESTDIR$TARGETDIR/$PROGNAME".commit.*
Stefan Reinauerd7649122015-06-09 11:44:25 -0700637cp "$PROGNAME" $DESTDIR$TARGETDIR/"$PROGNAME.commit.$(git describe)"
Zheng Bao30b895f2013-02-06 18:04:40 +0800638
Stefan Reinauer074d9132009-09-26 16:43:17 +0000639if [ $SAVETEMPS -eq 0 ]; then
Stefan Reinauer699ac272015-06-05 12:43:28 -0700640 cleanup
Stefan Reinauer074d9132009-09-26 16:43:17 +0000641else
642 printf "Leaving temporary files around... ${green}ok${NC}\n"
643fi
644
Stefan Reinauer699ac272015-06-05 12:43:28 -0700645printf "\n${green}You can now run your $NAME toolchain from $TARGETDIR.${NC}\n"